diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/ht/ht-ppdu.h ns-3.39/src/wifi/model/ht/ht-ppdu.h
--- ns-3.38/src/wifi/model/ht/ht-ppdu.h	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/ht/ht-ppdu.h	2023-07-05 14:23:48.113428400 -0700
@@ -48,24 +48,12 @@
      * HT PHY header (HT-SIG1/2).
      * See section 19.3.9 in IEEE 802.11-2016.
      */
-    class HtSigHeader : public Header
+    class HtSigHeader
     {
       public:
         HtSigHeader();
 
         /**
-         * \brief Get the type ID.
-         * \return the object TypeId
-         */
-        static TypeId GetTypeId();
-
-        TypeId GetInstanceTypeId() const override;
-        void Print(std::ostream& os) const override;
-        uint32_t GetSerializedSize() const override;
-        void Serialize(Buffer::Iterator start) const override;
-        uint32_t Deserialize(Buffer::Iterator start) override;
-
-        /**
          * Fill the MCS field of HT-SIG.
          *
          * \param mcs the MCS field of HT-SIG
@@ -139,16 +127,14 @@
      *
      * \param psdu the PHY payload (PSDU)
      * \param txVector the TXVECTOR that was used for this PPDU
-     * \param txCenterFreq the center frequency (MHz) that was used for this PPDU
+     * \param channel the operating channel of the PHY used to transmit this PPDU
      * \param ppduDuration the transmission duration of this PPDU
-     * \param band the WifiPhyBand used for the transmission of this PPDU
      * \param uid the unique ID of this PPDU
      */
     HtPpdu(Ptr<const WifiPsdu> psdu,
            const WifiTxVector& txVector,
-           uint16_t txCenterFreq,
+           const WifiPhyOperatingChannel& channel,
            Time ppduDuration,
-           WifiPhyBand band,
            uint64_t uid);
 
     Time GetTxDuration() const override;
@@ -196,10 +182,8 @@
                                    const LSigHeader& lSig,
                                    const HtSigHeader& htSig) const;
 
-#ifndef NS3_BUILD_PROFILE_DEBUG
     HtSigHeader m_htSig; //!< the HT-SIG PHY header
-#endif
-}; // class HtPpdu
+};                       // class HtPpdu
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/interference-helper.cc ns-3.39/src/wifi/model/interference-helper.cc
--- ns-3.38/src/wifi/model/interference-helper.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/interference-helper.cc	2023-07-05 14:23:48.113428400 -0700
@@ -28,6 +28,7 @@
 #include "ns3/log.h"
 #include "ns3/packet.h"
 #include "ns3/simulator.h"
+#include "ns3/wifi-phy-operating-channel.h"
 
 #include <algorithm>
 #include <numeric>
@@ -90,19 +91,18 @@
 {
     NS_ASSERT(!m_rxPowerW.empty());
     // The total RX power corresponds to the maximum over all the bands
-    auto it = std::max_element(
-        m_rxPowerW.begin(),
-        m_rxPowerW.end(),
-        [](const std::pair<WifiSpectrumBand, double>& p1,
-           const std::pair<WifiSpectrumBand, double>& p2) { return p1.second < p2.second; });
+    auto it =
+        std::max_element(m_rxPowerW.cbegin(),
+                         m_rxPowerW.cend(),
+                         [](const auto& p1, const auto& p2) { return p1.second < p2.second; });
     return it->second;
 }
 
 double
-Event::GetRxPowerW(WifiSpectrumBand band) const
+Event::GetRxPowerW(const WifiSpectrumBandInfo& band) const
 {
-    auto it = m_rxPowerW.find(band);
-    NS_ASSERT(it != m_rxPowerW.end());
+    const auto it = m_rxPowerW.find(band);
+    NS_ASSERT(it != m_rxPowerW.cend());
     return it->second;
 }
 
@@ -208,7 +208,12 @@
 InterferenceHelper::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    RemoveBands();
+    for (auto it : m_niChanges)
+    {
+        it.second.clear();
+    }
+    m_niChanges.clear();
+    m_firstPowers.clear();
     m_errorRateModel = nullptr;
 }
 
@@ -232,34 +237,75 @@
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_QOSDATA);
     hdr.SetQosTid(0);
-    Ptr<WifiPpdu> fakePpdu =
-        Create<WifiPpdu>(Create<WifiPsdu>(Create<Packet>(0), hdr), WifiTxVector(), 0);
+    Ptr<WifiPpdu> fakePpdu = Create<WifiPpdu>(Create<WifiPsdu>(Create<Packet>(0), hdr),
+                                              WifiTxVector(),
+                                              WifiPhyOperatingChannel());
     Add(fakePpdu, WifiTxVector(), duration, rxPowerW);
 }
 
-void
-InterferenceHelper::RemoveBands()
+bool
+InterferenceHelper::HasBands() const
 {
-    NS_LOG_FUNCTION(this);
-    for (auto it : m_niChangesPerBand)
-    {
-        it.second.clear();
-    }
-    m_niChangesPerBand.clear();
-    m_firstPowerPerBand.clear();
+    return !m_niChanges.empty();
+}
+
+bool
+InterferenceHelper::HasBand(const WifiSpectrumBandInfo& band) const
+{
+    return (m_niChanges.count(band) > 0);
 }
 
 void
-InterferenceHelper::AddBand(WifiSpectrumBand band)
+InterferenceHelper::AddBand(const WifiSpectrumBandInfo& band)
 {
-    NS_LOG_FUNCTION(this << band.first << band.second);
-    NS_ASSERT(m_niChangesPerBand.find(band) == m_niChangesPerBand.end());
+    NS_LOG_FUNCTION(this << band);
+    NS_ASSERT(m_niChanges.count(band) == 0);
+    NS_ASSERT(m_firstPowers.count(band) == 0);
     NiChanges niChanges;
-    auto result = m_niChangesPerBand.insert({band, niChanges});
+    auto result = m_niChanges.insert({band, niChanges});
     NS_ASSERT(result.second);
     // Always have a zero power noise event in the list
     AddNiChangeEvent(Time(0), NiChange(0.0, nullptr), result.first);
-    m_firstPowerPerBand.insert({band, 0.0});
+    m_firstPowers.insert({band, 0.0});
+}
+
+void
+InterferenceHelper::UpdateBands(const std::vector<WifiSpectrumBandInfo>& bands,
+                                const FrequencyRange& freqRange)
+{
+    NS_LOG_FUNCTION(this << freqRange);
+    for (auto it = m_niChanges.begin(); it != m_niChanges.end();)
+    {
+        if (!IsBandInFrequencyRange(it->first, freqRange))
+        {
+            it++;
+            continue;
+        }
+        const auto frequencies = it->first.frequencies;
+        const auto found =
+            std::find_if(bands.cbegin(), bands.cend(), [frequencies](const auto& item) {
+                return frequencies == item.frequencies;
+            }) != std::end(bands);
+        if (!found)
+        {
+            // band does not belong to the new bands, erase it
+            m_firstPowers.erase(it->first);
+            it->second.clear();
+            it = m_niChanges.erase(it);
+        }
+        else
+        {
+            it++;
+        }
+    }
+    for (const auto& band : bands)
+    {
+        if (!HasBand(band))
+        {
+            // this is a new band, add it
+            AddBand(band);
+        }
+    }
 }
 
 void
@@ -287,11 +333,12 @@
 }
 
 Time
-InterferenceHelper::GetEnergyDuration(double energyW, WifiSpectrumBand band)
+InterferenceHelper::GetEnergyDuration(double energyW, const WifiSpectrumBandInfo& band)
 {
+    NS_LOG_FUNCTION(this << energyW << band);
     Time now = Simulator::Now();
-    auto niIt = m_niChangesPerBand.find(band);
-    NS_ASSERT(niIt != m_niChangesPerBand.end());
+    auto niIt = m_niChanges.find(band);
+    NS_ABORT_IF(niIt == m_niChanges.end());
     auto i = GetPreviousPosition(now, niIt);
     Time end = i->first;
     for (; i != niIt->second.end(); ++i)
@@ -310,11 +357,10 @@
 InterferenceHelper::AppendEvent(Ptr<Event> event, bool isStartOfdmaRxing)
 {
     NS_LOG_FUNCTION(this << event << isStartOfdmaRxing);
-    for (const auto& it : event->GetRxPowerWPerBand())
+    for (const auto& [band, power] : event->GetRxPowerWPerBand())
     {
-        WifiSpectrumBand band = it.first;
-        auto niIt = m_niChangesPerBand.find(band);
-        NS_ASSERT(niIt != m_niChangesPerBand.end());
+        auto niIt = m_niChanges.find(band);
+        NS_ABORT_IF(niIt == m_niChanges.end());
         double previousPowerStart = 0;
         double previousPowerEnd = 0;
         auto previousPowerPosition = GetPreviousPosition(event->GetStartTime(), niIt);
@@ -322,23 +368,23 @@
         previousPowerEnd = GetPreviousPosition(event->GetEndTime(), niIt)->second.GetPower();
         if (!m_rxing)
         {
-            m_firstPowerPerBand.find(band)->second = previousPowerStart;
+            m_firstPowers.find(band)->second = previousPowerStart;
             // Always leave the first zero power noise event in the list
             niIt->second.erase(++(niIt->second.begin()), ++previousPowerPosition);
         }
         else if (isStartOfdmaRxing)
         {
-            // When the first UL-OFDMA payload is received, we need to set m_firstPowerPerBand
+            // When the first UL-OFDMA payload is received, we need to set m_firstPowers
             // so that it takes into account interferences that arrived between the start of the
             // UL MU transmission and the start of UL-OFDMA payload.
-            m_firstPowerPerBand.find(band)->second = previousPowerStart;
+            m_firstPowers.find(band)->second = previousPowerStart;
         }
         auto first =
             AddNiChangeEvent(event->GetStartTime(), NiChange(previousPowerStart, event), niIt);
         auto last = AddNiChangeEvent(event->GetEndTime(), NiChange(previousPowerEnd, event), niIt);
         for (auto i = first; i != last; ++i)
         {
-            i->second.AddPower(it.second);
+            i->second.AddPower(power);
         }
     }
 }
@@ -348,16 +394,15 @@
 {
     NS_LOG_FUNCTION(this << event);
     // This is called for UL MU events, in order to scale power as long as UL MU PPDUs arrive
-    for (const auto& it : rxPower)
+    for (const auto& [band, power] : rxPower)
     {
-        WifiSpectrumBand band = it.first;
-        auto niIt = m_niChangesPerBand.find(band);
-        NS_ASSERT(niIt != m_niChangesPerBand.end());
+        auto niIt = m_niChanges.find(band);
+        NS_ABORT_IF(niIt == m_niChanges.end());
         auto first = GetPreviousPosition(event->GetStartTime(), niIt);
         auto last = GetPreviousPosition(event->GetEndTime(), niIt);
         for (auto i = first; i != last; ++i)
         {
-            i->second.AddPower(it.second);
+            i->second.AddPower(power);
         }
     }
     event->UpdateRxPowerW(rxPower);
@@ -398,21 +443,21 @@
 double
 InterferenceHelper::CalculateNoiseInterferenceW(Ptr<Event> event,
                                                 NiChangesPerBand* nis,
-                                                WifiSpectrumBand band) const
+                                                const WifiSpectrumBandInfo& band) const
 {
-    NS_LOG_FUNCTION(this << band.first << band.second);
-    auto firstPower_it = m_firstPowerPerBand.find(band);
-    NS_ASSERT(firstPower_it != m_firstPowerPerBand.end());
+    NS_LOG_FUNCTION(this << band);
+    auto firstPower_it = m_firstPowers.find(band);
+    NS_ABORT_IF(firstPower_it == m_firstPowers.end());
     double noiseInterferenceW = firstPower_it->second;
-    auto niIt = m_niChangesPerBand.find(band);
-    NS_ASSERT(niIt != m_niChangesPerBand.end());
+    auto niIt = m_niChanges.find(band);
+    NS_ABORT_IF(niIt == m_niChanges.end());
     auto it = niIt->second.find(event->GetStartTime());
     for (; it != niIt->second.end() && it->first < Simulator::Now(); ++it)
     {
         noiseInterferenceW = it->second.GetPower() - event->GetRxPowerW(band);
     }
     it = niIt->second.find(event->GetStartTime());
-    NS_ASSERT(it != niIt->second.end());
+    NS_ABORT_IF(it == niIt->second.end());
     for (; it != niIt->second.end() && it->second.GetEvent() != event; ++it)
     {
         ;
@@ -477,12 +522,11 @@
 InterferenceHelper::CalculatePayloadPer(Ptr<const Event> event,
                                         uint16_t channelWidth,
                                         NiChangesPerBand* nis,
-                                        WifiSpectrumBand band,
+                                        const WifiSpectrumBandInfo& band,
                                         uint16_t staId,
                                         std::pair<Time, Time> window) const
 {
-    NS_LOG_FUNCTION(this << channelWidth << band.first << band.second << staId << window.first
-                         << window.second);
+    NS_LOG_FUNCTION(this << channelWidth << band << staId << window.first << window.second);
     double psr = 1.0; /* Packet Success Rate */
     const auto& niIt = nis->find(band)->second;
     auto j = niIt.cbegin();
@@ -498,7 +542,8 @@
     }
     Time windowStart = phyPayloadStart + window.first;
     Time windowEnd = phyPayloadStart + window.second;
-    double noiseInterferenceW = m_firstPowerPerBand.find(band)->second;
+    NS_ABORT_IF(m_firstPowers.count(band) == 0);
+    double noiseInterferenceW = m_firstPowers.at(band);
     double powerW = event->GetRxPowerW(band);
     while (++j != niIt.cend())
     {
@@ -548,10 +593,10 @@
     Ptr<const Event> event,
     NiChangesPerBand* nis,
     uint16_t channelWidth,
-    WifiSpectrumBand band,
+    const WifiSpectrumBandInfo& band,
     PhyEntity::PhyHeaderSections phyHeaderSections) const
 {
-    NS_LOG_FUNCTION(this << band.first << band.second);
+    NS_LOG_FUNCTION(this << band);
     double psr = 1.0; /* Packet Success Rate */
     auto niIt = nis->find(band)->second;
     auto j = niIt.begin();
@@ -564,7 +609,8 @@
     }
 
     Time previous = j->first;
-    double noiseInterferenceW = m_firstPowerPerBand.find(band)->second;
+    NS_ABORT_IF(m_firstPowers.count(band) == 0);
+    double noiseInterferenceW = m_firstPowers.at(band);
     double powerW = event->GetRxPowerW(band);
     while (++j != niIt.end())
     {
@@ -610,10 +656,10 @@
 InterferenceHelper::CalculatePhyHeaderPer(Ptr<const Event> event,
                                           NiChangesPerBand* nis,
                                           uint16_t channelWidth,
-                                          WifiSpectrumBand band,
+                                          const WifiSpectrumBandInfo& band,
                                           WifiPpduField header) const
 {
-    NS_LOG_FUNCTION(this << band.first << band.second << header);
+    NS_LOG_FUNCTION(this << band << header);
     auto niIt = nis->find(band)->second;
     auto phyEntity = WifiPhy::GetStaticPhyEntity(event->GetTxVector().GetModulationClass());
 
@@ -635,15 +681,15 @@
     return 1 - psr;
 }
 
-struct PhyEntity::SnrPer
+PhyEntity::SnrPer
 InterferenceHelper::CalculatePayloadSnrPer(Ptr<Event> event,
                                            uint16_t channelWidth,
-                                           WifiSpectrumBand band,
+                                           const WifiSpectrumBandInfo& band,
                                            uint16_t staId,
                                            std::pair<Time, Time> relativeMpduStartStop) const
 {
-    NS_LOG_FUNCTION(this << channelWidth << band.first << band.second << staId
-                         << relativeMpduStartStop.first << relativeMpduStartStop.second);
+    NS_LOG_FUNCTION(this << channelWidth << band << staId << relativeMpduStartStop.first
+                         << relativeMpduStartStop.second);
     NiChangesPerBand ni;
     double noiseInterferenceW = CalculateNoiseInterferenceW(event, &ni, band);
     double snr = CalculateSnr(event->GetRxPowerW(band),
@@ -663,7 +709,7 @@
 InterferenceHelper::CalculateSnr(Ptr<Event> event,
                                  uint16_t channelWidth,
                                  uint8_t nss,
-                                 WifiSpectrumBand band) const
+                                 const WifiSpectrumBandInfo& band) const
 {
     NiChangesPerBand ni;
     double noiseInterferenceW = CalculateNoiseInterferenceW(event, &ni, band);
@@ -671,13 +717,13 @@
     return snr;
 }
 
-struct PhyEntity::SnrPer
+PhyEntity::SnrPer
 InterferenceHelper::CalculatePhyHeaderSnrPer(Ptr<Event> event,
                                              uint16_t channelWidth,
-                                             WifiSpectrumBand band,
+                                             const WifiSpectrumBandInfo& band,
                                              WifiPpduField header) const
 {
-    NS_LOG_FUNCTION(this << band.first << band.second << header);
+    NS_LOG_FUNCTION(this << band << header);
     NiChangesPerBand ni;
     double noiseInterferenceW = CalculateNoiseInterferenceW(event, &ni, band);
     double snr = CalculateSnr(event->GetRxPowerW(band), noiseInterferenceW, channelWidth, 1);
@@ -690,19 +736,6 @@
     return PhyEntity::SnrPer(snr, per);
 }
 
-void
-InterferenceHelper::EraseEvents()
-{
-    for (auto niIt = m_niChangesPerBand.begin(); niIt != m_niChangesPerBand.end(); ++niIt)
-    {
-        niIt->second.clear();
-        // Always have a zero power noise event in the list
-        AddNiChangeEvent(Time(0), NiChange(0.0, nullptr), niIt);
-        m_firstPowerPerBand.at(niIt->first) = 0.0;
-    }
-    m_rxing = false;
-}
-
 InterferenceHelper::NiChanges::iterator
 InterferenceHelper::GetNextPosition(Time moment, NiChangesPerBand::iterator niIt)
 {
@@ -733,18 +766,30 @@
 }
 
 void
-InterferenceHelper::NotifyRxEnd(Time endTime)
+InterferenceHelper::NotifyRxEnd(Time endTime, const FrequencyRange& freqRange)
 {
-    NS_LOG_FUNCTION(this << endTime);
+    NS_LOG_FUNCTION(this << endTime << freqRange);
     m_rxing = false;
-    // Update m_firstPowerPerBand for frame capture
-    for (auto niIt = m_niChangesPerBand.begin(); niIt != m_niChangesPerBand.end(); ++niIt)
+    // Update m_firstPowers for frame capture
+    for (auto niIt = m_niChanges.begin(); niIt != m_niChanges.end(); ++niIt)
     {
+        if (!IsBandInFrequencyRange(niIt->first, freqRange))
+        {
+            continue;
+        }
         NS_ASSERT(niIt->second.size() > 1);
         auto it = GetPreviousPosition(endTime, niIt);
         it--;
-        m_firstPowerPerBand.find(niIt->first)->second = it->second.GetPower();
+        m_firstPowers.find(niIt->first)->second = it->second.GetPower();
     }
 }
 
+bool
+InterferenceHelper::IsBandInFrequencyRange(const WifiSpectrumBandInfo& band,
+                                           const FrequencyRange& freqRange) const
+{
+    return ((band.frequencies.second > (freqRange.minFrequency * 1e6)) &&
+            (band.frequencies.first < (freqRange.maxFrequency * 1e6)));
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/interference-helper.h ns-3.39/src/wifi/model/interference-helper.h
--- ns-3.38/src/wifi/model/interference-helper.h	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/interference-helper.h	2023-07-05 14:23:48.113428400 -0700
@@ -90,7 +90,7 @@
      * \param band the band for which the power should be returned
      * \return the received power (W) for a given band
      */
-    double GetRxPowerW(WifiSpectrumBand band) const;
+    double GetRxPowerW(const WifiSpectrumBandInfo& band) const;
     /**
      * Return the received power (W) for all bands.
      *
@@ -147,14 +147,26 @@
     /**
      * Add a frequency band.
      *
-     * \param band the band to be created
+     * \param band the band to be added
      */
-    void AddBand(WifiSpectrumBand band);
+    void AddBand(const WifiSpectrumBandInfo& band);
 
     /**
-     * Remove the frequency bands.
+     * Check whether bands are already tracked by this interference helper.
+     *
+     * \return true if bands are tracked by this interference helper, false otherwise
+     */
+    bool HasBands() const;
+
+    /**
+     * Update the frequency bands that belongs to a given frequency range when the spectrum model is
+     * changed.
+     *
+     * \param bands the bands to be added in the new spectrum model
+     * \param freqRange the frequency range the bands belong to
      */
-    void RemoveBands();
+    void UpdateBands(const std::vector<WifiSpectrumBandInfo>& bands,
+                     const FrequencyRange& freqRange);
 
     /**
      * Set the noise figure.
@@ -191,7 +203,7 @@
      *          energy on the medium for a given band will
      *          be higher than the requested threshold.
      */
-    Time GetEnergyDuration(double energyW, WifiSpectrumBand band);
+    Time GetEnergyDuration(double energyW, const WifiSpectrumBandInfo& band);
 
     /**
      * Add the PPDU-related signal to interference helper.
@@ -234,12 +246,11 @@
      *
      * \return struct of SNR and PER (with PER being evaluated over the provided time window)
      */
-    struct PhyEntity::SnrPer CalculatePayloadSnrPer(
-        Ptr<Event> event,
-        uint16_t channelWidth,
-        WifiSpectrumBand band,
-        uint16_t staId,
-        std::pair<Time, Time> relativeMpduStartStop) const;
+    PhyEntity::SnrPer CalculatePayloadSnrPer(Ptr<Event> event,
+                                             uint16_t channelWidth,
+                                             const WifiSpectrumBandInfo& band,
+                                             uint16_t staId,
+                                             std::pair<Time, Time> relativeMpduStartStop) const;
     /**
      * Calculate the SNIR for the event (starting from now until the event end).
      *
@@ -253,7 +264,7 @@
     double CalculateSnr(Ptr<Event> event,
                         uint16_t channelWidth,
                         uint8_t nss,
-                        WifiSpectrumBand band) const;
+                        const WifiSpectrumBandInfo& band) const;
     /**
      * Calculate the SNIR at the start of the PHY header and accumulate
      * all SNIR changes in the SNIR vector.
@@ -265,10 +276,10 @@
      *
      * \return struct of SNR and PER
      */
-    struct PhyEntity::SnrPer CalculatePhyHeaderSnrPer(Ptr<Event> event,
-                                                      uint16_t channelWidth,
-                                                      WifiSpectrumBand band,
-                                                      WifiPpduField header) const;
+    PhyEntity::SnrPer CalculatePhyHeaderSnrPer(Ptr<Event> event,
+                                               uint16_t channelWidth,
+                                               const WifiSpectrumBandInfo& band,
+                                               WifiPpduField header) const;
 
     /**
      * Notify that RX has started.
@@ -278,12 +289,9 @@
      * Notify that RX has ended.
      *
      * \param endTime the end time of the signal
+     * \param freqRange the frequency range in which the received signal event had been detected
      */
-    void NotifyRxEnd(Time endTime);
-    /**
-     * Erase all events.
-     */
-    void EraseEvents();
+    void NotifyRxEnd(Time endTime, const FrequencyRange& freqRange);
 
     /**
      * Update event to scale its received power (W) per band.
@@ -386,12 +394,35 @@
     /**
      * typedef for a multimap of NiChange
      */
-    typedef std::multimap<Time, NiChange> NiChanges;
+    using NiChanges = std::multimap<Time, NiChange>;
 
     /**
      * Map of NiChanges per band
      */
-    typedef std::map<WifiSpectrumBand, NiChanges> NiChangesPerBand;
+    using NiChangesPerBand = std::map<WifiSpectrumBandInfo, NiChanges>;
+
+    /**
+     * Map of first power per band
+     */
+    using FirstPowerPerBand = std::map<WifiSpectrumBandInfo, double>;
+
+    /**
+     * Check whether a given band is tracked by this interference helper.
+     *
+     * \param band the band to be checked
+     * \return true if the band is already tracked by this interference helper, false otherwise
+     */
+    bool HasBand(const WifiSpectrumBandInfo& band) const;
+
+    /**
+     * Check whether a given band belongs to a given frequency range.
+     *
+     * \param band the band to be checked
+     * \param freqRange the frequency range to check whether the band belong to
+     * \return true if the band belongs to the frequency range, false otherwise
+     */
+    bool IsBandInFrequencyRange(const WifiSpectrumBandInfo& band,
+                                const FrequencyRange& freqRange) const;
 
     /**
      * Append the given Event.
@@ -413,7 +444,7 @@
      */
     double CalculateNoiseInterferenceW(Ptr<Event> event,
                                        NiChangesPerBand* nis,
-                                       WifiSpectrumBand band) const;
+                                       const WifiSpectrumBandInfo& band) const;
     /**
      * Calculate the error rate of the given PHY payload only in the provided time
      * window (thus enabling per MPDU PER information). The PHY payload can be divided into
@@ -431,7 +462,7 @@
     double CalculatePayloadPer(Ptr<const Event> event,
                                uint16_t channelWidth,
                                NiChangesPerBand* nis,
-                               WifiSpectrumBand band,
+                               const WifiSpectrumBandInfo& band,
                                uint16_t staId,
                                std::pair<Time, Time> window) const;
     /**
@@ -449,7 +480,7 @@
     double CalculatePhyHeaderPer(Ptr<const Event> event,
                                  NiChangesPerBand* nis,
                                  uint16_t channelWidth,
-                                 WifiSpectrumBand band,
+                                 const WifiSpectrumBandInfo& band,
                                  WifiPpduField header) const;
     /**
      * Calculate the success rate of the PHY header sections for the provided event.
@@ -465,15 +496,15 @@
     double CalculatePhyHeaderSectionPsr(Ptr<const Event> event,
                                         NiChangesPerBand* nis,
                                         uint16_t channelWidth,
-                                        WifiSpectrumBand band,
+                                        const WifiSpectrumBandInfo& band,
                                         PhyEntity::PhyHeaderSections phyHeaderSections) const;
 
     double m_noiseFigure;                 //!< noise figure (linear)
     Ptr<ErrorRateModel> m_errorRateModel; //!< error rate model
-    uint8_t m_numRxAntennas; //!< the number of RX antennas in the corresponding receiver
-    NiChangesPerBand m_niChangesPerBand;                    //!< NI Changes for each band
-    std::map<WifiSpectrumBand, double> m_firstPowerPerBand; //!< first power of each band in watts
-    bool m_rxing; //!< flag whether it is in receiving state
+    uint8_t m_numRxAntennas;         //!< the number of RX antennas in the corresponding receiver
+    NiChangesPerBand m_niChanges;    //!< NI Changes for each band
+    FirstPowerPerBand m_firstPowers; //!< first power of each band in watts
+    bool m_rxing;                    //!< flag whether it is in receiving state
 
     /**
      * Returns an iterator to the first NiChange that is later than moment
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/mac-rx-middle.cc ns-3.39/src/wifi/model/mac-rx-middle.cc
--- ns-3.38/src/wifi/model/mac-rx-middle.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/mac-rx-middle.cc	2023-07-05 14:23:48.113428400 -0700
@@ -134,15 +134,8 @@
      */
     bool IsNextFragment(uint16_t sequenceControl) const
     {
-        if ((sequenceControl >> 4) == (m_lastSequenceControl >> 4) &&
-            (sequenceControl & 0x0f) == ((m_lastSequenceControl & 0x0f) + 1))
-        {
-            return true;
-        }
-        else
-        {
-            return false;
-        }
+        return (sequenceControl >> 4) == (m_lastSequenceControl >> 4) &&
+               (sequenceControl & 0x0f) == ((m_lastSequenceControl & 0x0f) + 1);
     }
 
     /**
@@ -230,11 +223,7 @@
 MacRxMiddle::IsDuplicate(const WifiMacHeader* hdr, OriginatorRxStatus* originator) const
 {
     NS_LOG_FUNCTION(hdr << originator);
-    if (hdr->IsRetry() && originator->GetLastSequenceControl() == hdr->GetSequenceControl())
-    {
-        return true;
-    }
-    return false;
+    return hdr->IsRetry() && originator->GetLastSequenceControl() == hdr->GetSequenceControl();
 }
 
 Ptr<const Packet>
